import Vue from 'vue'
import '@/styles/index.scss' // global css
import ElementUI from 'element-ui'
import Fit2CloudUI from 'fit2cloud-ui'

import i18n from './lang' // internationalization
import App from './App'
import store from './store'
import router from './router'
import message from './utils/message'
import '@/icons' // icon
import directives from './directive'
import widgets from '@/components/widget'
import '@/components/canvas/custom-component' // 注册自定义组件

Vue.config.productionTip = false

import * as echarts from 'echarts'

Vue.prototype.$echarts = echarts
import 'umy-ui/lib/theme-chalk/index.css'
import UmyUi from 'umy-ui'
Vue.use(UmyUi)

Vue.use(widgets)
Vue.use(directives)
// 全屏插件
import fullscreen from 'vue-fullscreen'
Vue.use(fullscreen)

// 如果想要中文版 element-ui，按如下方式声明
Vue.use(ElementUI, {
  i18n: (key, value) => i18n.t(key, value)
})
Vue.use(Fit2CloudUI, {
  i18n: (key, value) => i18n.t(key, value)
})
// Vue.use(VueAxios, axios)
Vue.use(message)
Vue.config.productionTip = false

new Vue({
  router,
  store,
  i18n,
  render: h => h(App)
}).$mount('#app')
